# Profinet

The Profinet protocol may require root permissions in some constellations. If you experience problems with running this protocol, please make sure to install your service on an agent with root permissions as described in [agent orchestration](/1-7-2/documentation/agents/installation.md#orchestration).

## Overview

Profinet (usually styled as **PROFINET**, as a portmanteau for Process Field Net) is an industry technical standard for data communication over Industrial Ethernet, designed for collecting data from, and controlling equipment in industrial systems, with a particular strength in delivering data under tight time constraints.

This protocol is optional and subject to license. It should be installed on demand.

[Connection Properties](/1-7-2/documentation/industry-protocol-details/profinet/profinetconnection.md)

[Endpoint Properties](/1-7-2/documentation/industry-protocol-details/profinet/profinetendpoint.md)

## Sample commissioning file

Download:

{% file src="/files/ZzK74L4auil4vdubwHrn" %}

```yaml
---
description: >
    Sample Profinet commissioning file

metadata:
    name: Profinet example
    icon: https://www.cybus.io/wp-content/uploads/2017/10/for-whom1.svg
    provider: cybus
    homepage: https://www.cybus.io
    version: 1.0.0

resources:
    profinetConnection:
        type: Cybus::Connection
        properties:
            protocol: Profinet
            connection:
                localInterface: 'eth0'
                gsdPath: '/app/gsd-files' # These paths are referenced between the container
                configPath: '/app/profinet-config'
                connectionStrategy:
                    initialDelay: 1000
                    maxDelay: 30000
                    incrementFactor: 2

    endpoint1:
        type: Cybus::Endpoint
        properties:
            protocol: Profinet
            connection: !ref profinetConnection
            subscribe:
                deviceName: 'netx52repns'
                api: 0
                slot: 0
                subSlot: 0
                propertyIndex: 0

    mapping:
        type: Cybus::Mapping
        properties:
            mappings:
                - subscribe:
                      endpoint: !ref endpoint1
                  publish:
                      topic: 'netx52rens_output'
```

## Output Format

The data will be written as a JSON object with a *timestamp* and a data member called *value*.

For example for the endpoint *endpoint1*, the output will be:

```yaml
{ 'timestamp': 1581932492902, 'value': [0, 1, 0, 0] }
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cybus.io/1-7-2/documentation/industry-protocol-details/profinet.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
